Attribute VB_Name = "mdlMain"
Option Explicit

Public Shafts() As clsShaft
Public Floors() As clsFloor


Public fReady As Boolean
Public fPending As Boolean
Public fClose As Boolean


Public nLevels As Integer
Public nShafts As Integer

Public InBuffer As String

Enum ModifyUICOnstants
    UI_Closed
    UI_Pending
    UI_Connected
End Enum



Sub ResetEnvironment()
With frmMain
.lstConsole.Clear
.txtLevels.Text = ""
.txtShafts.Text = ""
End With

fReady = False
fPending = False
fClose = False
nLevels = 0
nShafts = 0
InBuffer = ""
End Sub

Sub ValidateBuffer()
Dim nPos As Integer, sEvent As String

nPos = InStr(1, InBuffer, vbCrLf)
If nPos > 0 Then
    sEvent = Left$(InBuffer, nPos - 1)
    InBuffer = Right$(InBuffer, Len(InBuffer) - nPos - 1)
    ValidateEvent sEvent
    ValidateBuffer
End If

End Sub

Sub ValidateEvent(sEvent As String)
Dim sEventName As String

Dim nThis As Integer, nLevel As Integer, c As Integer

With frmMain
    .lstConsole.AddItem sEvent
    .lstConsole.ListIndex = .lstConsole.ListCount - 1
End With

sEventName = GetEventName(sEvent)
If Not fReady And Not (LCase$(sEventName)) = "shafts" And Not (LCase$(sEventName)) = "levels" Then Exit Sub
Select Case LCase$(sEventName)
        Case "shafts"
            nShafts = Val(GetParam(sEvent, 1))
            ReInit
        Case "levels"
            nLevels = Val(GetParam(sEvent, 1))
            ReInit
        
        Case "closed"
            nThis = Val(GetParam(sEvent, 1))
            Shafts(nThis).Closed = True
            Shafts(nThis).GetNextTarget
            If Shafts(nThis).fHasTarget Then
                Shafts(nThis).GoToTarget
                Shafts(nThis).OpenDoor
            End If
        
        Case "opened"
            nThis = Val(GetParam(sEvent, 1))
            Send "indidnoff " & Shafts(nThis).nTarget & vbCrLf
            Floors(Shafts(nThis).nTarget).fButtonDown = False
            Send "indiupoff " & Shafts(nThis).nTarget & vbCrLf
            Floors(Shafts(nThis).nTarget).fButtonUp = False
            Send "indioff " & nThis & " " & Shafts(nThis).nTarget & vbCrLf
            Shafts(nThis).SetFloor Shafts(nThis).nTarget, False
            If nThis < nShafts Then
                Shafts(nThis).Closed = False
                Shafts(nThis).dClosingTime = Timer + 1
                Shafts(nThis).fToBeClosed = True
            End If
            
        Case "levelbuttondn"
            nLevel = Val(GetParam(sEvent, 1))
            Send "indidnon " & nLevel & vbCrLf
            Floors(nLevel).fButtonDown = True
            For c = 0 To nShafts - 1
                If Not Shafts(c).fHasTarget Then
                    Shafts(c).GetNextTarget
                    Shafts(c).CloseDoor
                End If
            Next c
        
        Case "levelbuttonup"
            nLevel = Val(GetParam(sEvent, 1))
            Send "indiupon " & nLevel & vbCrLf
            Floors(nLevel).fButtonUp = True
            For c = 0 To nShafts - 1
                If Not Shafts(c).fHasTarget Then
                    Shafts(c).GetNextTarget
                    Shafts(c).CloseDoor
                End If
            Next c
            
        Case "cabinbutton"
            nThis = Val(GetParam(sEvent, 1))
            nLevel = Val(GetParam(sEvent, 2))
            Send "indion " & nThis & " " & nLevel & vbCrLf
            Shafts(nThis).SetFloor nLevel, True
            If Not Shafts(nThis).fHasTarget Then
                Shafts(nThis).GetNextTarget
                Shafts(nThis).CloseDoor
            End If
End Select
End Sub

Sub Send(sData As String)
If frmMain.sckClient.State = sckConnected Then frmMain.sckClient.SendData sData
End Sub

Sub ReInit()
    Dim c As Integer
    If nShafts > 0 And nLevels > 0 Then
        frmMain.txtShafts = nShafts
        frmMain.txtLevels = nLevels
        ReDim Shafts(0 To nShafts - 1)
        ReDim Floors(0 To nLevels - 1)
        For c = 0 To nShafts - 1
            Set Shafts(c) = New clsShaft
            Shafts(c).ID = c
            Send "close " & c & vbCrLf
        Next c
        For c = 0 To nLevels - 1
            Set Floors(c) = New clsFloor
        Next
        fReady = True
    End If
End Sub

Function GetParam(sEvent As String, nParam As Integer) As String
Dim nPos As Integer, nAct As Integer

Do
    nPos = InStr(nPos + 1, sEvent, " ")
    nAct = nAct + 1
Loop Until nPos = 0 Or nAct = nParam

If nPos = 0 Then
    GetParam = ""
Else
    GetParam = Right$(sEvent, Len(sEvent) - nPos)
    nPos = InStr(1, GetParam, " ")
    If nPos > 1 Then
        GetParam = Left$(GetParam, nPos - 1)
    End If
End If
    

End Function

Function GetEventName(sEvent As String) As String
Dim nPos As Integer
nPos = InStr(1, sEvent, " ")
If nPos > 1 Then
    GetEventName = Left$(sEvent, nPos - 1)
Else
    GetEventName = sEvent
End If
End Function

Sub ModifyUI(State As ModifyUICOnstants)

With frmMain
Select Case State
        Case UI_Closed
            .txtHost.Enabled = True
            .txtPort.Enabled = True
            .cmdClose.Visible = False
            '.cmdConnect.Enabled = True
            .cmdConnect.Visible = True
            .cmdConnect.Default = True
            .lblStatus.Caption = "Odpojeno"
        Case UI_Pending
            .txtHost.Enabled = False
            .txtPort.Enabled = False
            .cmdClose.Visible = True
            '.cmdConnect.Enabled = True
            .cmdConnect.Visible = False
            .cmdClose.Default = True
            .lblStatus.Caption = "Pipojovn"
        Case UI_Connected
            .txtHost.Enabled = False
            .txtPort.Enabled = False
            .cmdClose.Visible = True
            '.cmdConnect.Enabled = True
            .cmdConnect.Visible = False
            .cmdClose.Default = True
            .lblStatus.Caption = "Pipojeno"
End Select
End With

End Sub

Sub Wait(time As Double)
Dim t As Double
t = Timer
Do Until Timer > t + time
DoEvents
Loop
End Sub
